// DS1302:  CE pin    -> Arduino Digital 2
//          I/O pin   -> Arduino Digital 3
//          SCLK pin  -> Arduino Digital 4

//Added
#include <IRremote.hpp> //include the library
#define Button_1 0xFF30CF
#define Button_2 0xFF18E7
int receiver = 13; //initialize pin 13 as recevier pin.
uint32_t Previous; 
IRrecv irrecv(receiver); //create a new instance of receiver
decode_results results;
#include <LiquidCrystal.h>
#include <DS1302.h>
int Relay = 12;
DS1302 rtc(2, 3, 4);
LiquidCrystal lcd(11, 10, 9, 8, 7, 6);
Time t;
byte OnHour   = 23;
byte OnMin    = 46;
byte OnSec    = 00;
byte OffHour  = 23;
byte OffMin   = 46;
byte OffSec   = 05;
void setup()
{
  // Set the clock to run-mode, and disable the write protection
  rtc.halt(false);
  rtc.writeProtect(false);
  Serial.begin(115200);
  
  //ADDED!
  irrecv.enableIRIn(); //start the receiver
  //END OF ADDED!

  // Setup LCD to 16x2 characters
  lcd.begin(16, 2);

  
  
  pinMode(Relay,OUTPUT);
  digitalWrite(Relay, LOW);
  // The following lines can be commented out to use 
  // the values already stored in the DS1302
  rtc.setDOW(WEDNESDAY);      // Set Day-of-Week to FRIDAY (example)
  rtc.setTime(11, 19, 00);   // Set the time to 12:00:00 (24hr format)
  rtc.setDate(02, 02, 2022); // Set the date to month, day, year 
}

void loop()
{
  //ADDED
  if (irrecv.decode(&results)) { //if we have received an IR signal
  if (results.value==0xFFFFFFFF) { 
      results.value=Previous;
      }

    switch(results.value) {
           case Button_1 : digitalWrite(Relay, HIGH); break;
           case Button_2 : digitalWrite(Relay, LOW); break;
           
      } 
 Serial.println (results.value, HEX); //display HEX results
 irrecv.resume(); //next value
 }
 Previous=results.value;
 //ADDED END
  //start of lcd control
   // Display time centered on the upper line
  lcd.setCursor(4, 0);
  lcd.print(rtc.getTimeStr());
  
  // Display abbreviated Day-of-Week in the lower left corner
  lcd.setCursor(0, 1);
  lcd.print(rtc.getDOWStr(FORMAT_SHORT));
  
  // Display date in the lower right corner
  lcd.setCursor(6, 1);
  lcd.print(rtc.getDateStr());
  //end of lcd control
  t = rtc.getTime();
  Serial.print(t.dow);
  Serial.print(" ");
  Serial.print(t.date);
  Serial.print("/");
  Serial.print(t.mon);
  Serial.print("/");
  Serial.print(t.year);
  Serial.print(" ");
  Serial.print(t.hour);
  Serial.print(":");
  Serial.print(t.min);
  Serial.print(":");
  Serial.println(t.sec);
  Serial.println("*********");
  if (t.hour == OnHour && t.min == OnMin && OnSec == t.sec) {
    digitalWrite(Relay,HIGH);
    Serial.println("PUMP ON");
  }else if (t.hour == OffHour && t.min == OffMin && OffSec == t.sec) {
    digitalWrite(Relay,LOW);
    Serial.println("PUMP OFF"); 
  }
 delay (1000);
}
